!*************************** AMUS Program Label ******************************
! Filename: VANNA.RUN                                       Date: 06/05/89   !
! Category: GAME         Hash Code: 301-756-457-771      Version: 1.5(10)    !
!                                                                            !
! Initials: KON/AM       Name: MARC SHEPPARD                                 !
! Company: TRYMARC USA, INC.                       Telephone #: 5165896900   !
! Related Files: VANNA.DAT, VANNA.HLP, VANNA.INI, VANNA.PRZ                  !
! Min. Op. Sys.: 1.0                           Expertise Level: BEG          !
! Special: Requires no externs, however may use INFLD.SBR (See Vanna.Hlp)    !
! Description: Box of Fortune.                                               !
!                                                                            !
!*****************************************************************************

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!                     VANNA...aka BOX OF FORTUNE                         !!!
!!!             Written By M. Sheppard (KON/AM) on 05-Mar-88               !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!               Program Version 1.5 released on 12-Jan-92                !!!
!!!                 [*] = New or Modified for Version 1.5                  !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!									    !!!
!!!                     Vanna Version 1.5 Release Notes	                    !!!
!!!                                                                         !!!
!!!  Version 1.5 introduces new rules and new categories to the game.  The  !!!
!!!  new rules resemble those of that game on television (the name escapes  !!!
!!!  me). Some VANNA.INI defaults have been changed (the DRAG and SETFORCE  !!!
!!!  features didn't play the way I had envisioned)  and  the Speed of the  !!!
!!!  Graphics may now be modified using SLEEP.SBR (this helps  standardize  !!!
!!!  Animation and Banter speed across various microprocessors).    TRMCHR  !!!
!!!  is now used to determine whether your terminal utilizes Field or Mode  !!!
!!!  Attributes  (Now  Supported)  as  well  as  whether  or  not  it  has  !!!
!!!  box-drawing attributes. Additionally, a  new  Puzzle  File  has  been  !!!
!!!  supplied - this one in contiguous format.  Fear not,  the  sequential  !!!
!!!  format continues to be supported as well.                              !!!
!!!                                                                         !!!
!!!  FREE SPINS are awarded but once per round.   You MUST select a match-  !!!
!!!  ing letter after you have landed on the FREE SPIN  space  in order to  !!!
!!!  receive the FREE SPIN.  Prizes now work in much the same manner.       !!!
!!!                                                                         !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  NOTE:

  This  program  requires  no  external  sub-routines   and   is  therefore
  compatible  with  any  Alpha-Micro  Computer.   HOWEVER,  Extensive  Line
  Drawing Graphics are REQUIRED for the program to run properly, so not ALL
  CRT/TDV  combinations  will  produce  the desired results!  However,  any
  terminal  supporting the more commonly used  TCRT  calls  (Line  Drawing,
  Solid Block, Cross-Hatch Block, Blink, Reverse, and Reverse Blink) should
  do very nicely.


                                  =========
                                  VANNA.DAT
  [*]                             =========

  For those of you  who  wish  to  compose your own puzzle files, the input
  file,  (eg  "VANNA.DAT"), is formatted  sequentially.  Record  Format  is
  Simple: PUZZLE,  CATEGORY<CR/LF>.  When  adding  puzzles,  be  certain to
  follow  this format EXACTLY. Commas may ONLY BE USED to separate  PUZZLES
  from CATEGORIES!  Try  to  avoid  erroneous  TABS  and  SPACES after each
  CATEGORY, as well as any BLANK LINES between PUZZLES and at end of file !

  You  have  the  option  of  maintaining the file WITH or WITHOUT a header
  record. The header record, if  utilized,  is the first record in the file
  and contains the active puzzle count.  The  advantage  of  using a header
  record  is  in  the  fact  that the program need not calculate the  #  of
  puzzles prior to starting the  game.   If  you  do  not  plan  on  adding
  multitudes of puzzles at a time, you are best served maintaining a header
  record.  A facility is available to you for verifying the accuracy of the
  header puzzle count (see VERIFY under the VANNA.INI section).

  Only Letters (A-Z),  Hyphens  (-),  Apostrophes  ('), Ampersands (&), and
  Spaces  are supported ! The only other restriction  is  that  the  PUZZLE
  ITSELF May  Not  Exceed  48 Chrs, (Puzzle length MAY be 49 IF AND ONLY IF
  character in position 25 is a space) and that no one line (maximum 2) may
  exceed  24  characters.   You   MAY  Find  that  certain  <=48  character
  combinations DO NOT work properly,  as  a  line  break  is calculated <24
  characters and the remaining puzzle length exceeds 24. Such  Puzzles will
  be  reported  to  you at run-time and subsequently bypassed. Again,  when
  Adding New Puzzles, BE SURE to UPDATE PUZZLE COUNTER on LINE 1 if you are
  using a header record ! Maximum # of puzzles in any file is 4096 !

                                  =========
                                  VANNA.INI
                                  =========

  You may use a file named "VANNA.INI" to modify a few Parameters.

  The file may exist  either  LOCALLY (in each account where VANNA is being
  played)  or GLOBALLY (in the system  library  account-DSK0:[7,0]).  If  a
  GLOBAL file  is found, then any game invoked in an account which does not
  contain an INI file will adhere to the parameters specified in the GLOBAL
  file.

The current modifiable parameters are:

[*]  SLEEP      By loading  SLEEP.SBR  into  User  or  System  Memory,  and
                setting  SLEEP  to  ON, the SPEED setting will perform in a
                more uniform and predictable  manner.   This  is especially
                true with AM2000's and AM3000's.  DO NOT USE THIS OPTION IF
                YOU ARE USING A VERSION OF SLEEP.SBR GREATER THAN 1.0(100)!
                MILLISECONDS ARE NO LONGER SUPPORTED AS OF AMOS32 2.2A (WHY
                AFTER 15 YEARS IS ANYBODY'S GUESS) !?!  USING THE NEW SLEEP
                SUBROUTINE WILL RESULT IN VANNA AT WARP FACTOR TEN !!!!!!!!
                Default Value: FALSE

[*]  NEWPUZ     The New Contiguous Puzzle File is comprised of the original
                895  Puzzles   1st   introduced   in   version   1.0   PLUS
                approximately 1100 NEW puzzles.  If you have already played
                through the original puzzles (resulting in a BITMAP Reset),
                you have the option of playing  ONLY  THE  NEW  PUZZLES  by
                setting NEWPUZ to TRUE. If, on the other hand, you have not
                played all of the original puzzles,  your  existing  BITMAP
                (assuming you  didn't  grab  VANNA.BMP  from  the  Network)
                remains valid, and NEW PUZZLES will be  played  along  with
                Unused OLD PUZZLES.
                Default Value: FALSE

[*]  Terminal Attributes:
                If your  operating  system  is  recent  enough  to  include
                TRMCHR.SBR, the game will automatically  determine  whether
                you are using a FIELD or MODE attribute terminal, and paint
                the screen accordingly.  Additionally, if  Box  Drawing  is
                supported, it  will  be  utilized.    This  might  cause  a
                problem if the Terminal Driver you are  using  either  does
                not support TRMCHR or contains erroneous information in the
                TRMCHR routine (I have encountered this in many of the WY50
                drivers out there).  The following three  Commands  may  be
                used to manually set these terminal  characteristics.   See
                your SYSOP for further details.
                         
                         
[*]  MODEON     Forces MODE Attribute Support regardless of the information
                found in the Terminal Driver TRMCHR Routine.
   		Default Value: FALSE
                        

[*]  MODEOFF    Forces  FIELD   Attribute   Support   regardless   of   the
                information found in the Terminal Driver TRMCHR Routine.
                Default Value: FALSE     
                         

[*]  BOXOFF     Forces Box Drawing OFF regardless of the information  found
                in the Terminal Driver TRMCHR Routine.
                Default Value: FALSE     
                         

                               -------------------------
   
               
               
ODDS            Defines  the  odds (1:N) of WANNA missing a letter when she
                turns the puzzle over after it  is  solved.   ODDS  must be
                expressed as POSITIVE INTEGERS ONLY!  Expect some surprises
                if  she botches more than twice !!! (a 2 or 3 in this  spot
                will produce amusing results).
                Default Value: 3

BONUS           Defines  "BOTCH BONUS" ON or OFF.  Adds a bit  more jazz to
                the game.  Base Jackpot for Bonus Round is $25,000. If ODDS
                set >1 and WANNA Botches  Puzzle  then the BONUS amount for
                that round is added to the Jackpot.   In  Addition,  if She
                botches more than once, each subsequent botch will add  the
                BONUS  for  that round to the round winner's total dollars.
                Default Value: TRUE

BEEP            Defines  Terminal Beep ON or OFF.  For  best results, leave
                ON.  
                Default Value: TRUE

LOGIC           Defines Puzzle  size  logic  ON  or OFF. When enabled, this
                will force selection of larger Puzzles in rounds  4  and  5
                and  smaller  Puzzles  in Bonus Round, as defined by LOGMIN
                and LOGMAX. 
                Default Value: TRUE

LOGMIN          Defines the  minimum  size  of  a puzzle for Rounds 4 and 5
                when LOGIC is TRUE. (Should Not exceed 44 and best  results
                will be realized if between 30 and 40).
                Default Value: 25

LOGMAX          Defines  the maximum size of puzzle for  Bonus  Round  when
                LOGIC is TRUE. (Must be  at  least 12 and best results will
                be realized if at least 20).
                Default Value: 24

PASSES          Defines  #  of Attempts  per  puzzle  to  adhere  to  LOGIC
                parameters prior to a sequential search of the entire File.

                Puzzles are selected  randomly,  and duplicates are avoided
                utilizing   a   file  named  "VANNA.BMP".   When  a  random
                selection points  to a used puzzle another random selection
                is  made.  When  a  selected  puzzle  DOES  NOT  meet  size
                requirements, all Puzzles  from  that  point in the file to
                the  lowest  point  searched  sequentially  thus   far  are
                checked.    The   NEXT   puzzle   found  which  meets  size
                requirements  is then selected.  If  None  are  found,  the
                random process  begins  again  with  another PASS. Once the
                number of PASSES has been reached, a sequential  search  of
                the entire file is Begun.  If no matching Puzzles are found
                at  this point, the user will be notified and LOGIC for the
                remainder of the game will be nullified.

                The   More  PASSES  allowed  the  more  RANDOM  the  puzzle
                selection will be when  using  LOGIC.   However,  increased
                PASSES may also mean increased Wait Time, especially as the
                number   of   puzzles-used   approaches   the   number   of
                puzzles-on-file.

                Note:  You may reset the used puzzle BITMAP  by erasing the
                BITMAP  file  - "VANNA.BMP".  Be very careful to erase ONLY
                this file !
                Default Value: 7

DISPLAY         If  LOGIC  is  TRUE  you  may set this parameter to TRUE to
                DISPLAY # of PASSES expired in finding logical  Puzzle. You
                may  wish  to  set  this  to TRUE temporarily when changing
                other LOGIC parameters. 
                Default Value: FALSE

ATTEMPTS        Defines the #  of  Attempts  allowed by the Winner to solve
                the Bonus Round Puzzle. 
                Default Value: 3 (1 if using TIMEOUT feature).

SPEED           Defines the Wait Coefficient of  the  various Screen Output
                Routines.  The Higher the number, the shorter the wait, the
                faster the screen output.  Standard speed is 1.00. If  your
                system  is  heavily  loaded,  you  may find it desirable to
                increase this number !  If, on the other  hand, you wish to
                slow it down you may set it <1 (eg. .5 will  cut  speed  in
                half, 2 will double speed). 
                Default Value: 1.00

ROTATE          Defines whether or not to rotate dollar positions  on wheel
                after each round. 
                Default Value: TRUE

CHAIN           Allows  you  to  define  a program or command file name  to
                chain to upon exit of game. 
                Default Value: None

VERIFY          If Header Record is used,  you  may  set  VERIFY to TRUE to
                verify  the  puzzle  count  prior to 1st Puzzle.  If puzzle
                count does not match the number of puzzles, the discrepency
                will be reported to you.  This  parameter  is ignored if no
                header record is found or New  Contiguous  Puzzle  file  is
                Used.
                Default Value: FALSE

DATA            Defines  the  Name  and,  optionally,  the  location of the
                Puzzle File.

                If  you  wish to maintain multiple data files you  may  use
                this parameter to avoid  the  confusion  of  constant  file
                renaming.  This  is especially helpful should you decide to
                create special categorized files (eg you may wish to create
                1 file containing MOVIE puzzles, another containing SCIENCE
                puzzles, etc). Note:  This  parameter defines the ROOT FILE
                NAME ONLY. Do not attempt to  define  a  File Extension, as
                the  puzzle  file extension will ALWAYS be ".DAT"  and  the
                corresponding  bitmap file extension will ALWAYS be ".BMP". 
                When renaming PUZZLE FILES (".DAT") , be sure to rename the
                corresponding BITMAP FILES (".BMP").


                DATA  may  also  be  used  to place your puzzle file in any
                account  on the system and have all games played  from  any
                account access the global puzzle file (eg DSK0:VANNA[7,6]).
                (See GLOBAL). 
                Default Value: VANNA


GLOBAL          If you have  chosen  to  place your puzzle file in a global
                account you now have the option of maintaining  HIGH  SCORE
                and  BITMAP  Files  either locally or globally.  By setting
                GLOBAL to TRUE, the BITMAP  and  HIGH  SCORE  files will be
                maintained  in  the  same  account as the puzzle file.   If
                GLOBAL  is  FALSE then all games  will  access  the  global
                puzzle file,  however a separate BITMAP and HIGH SCORE file
                will be maintained  in  each  Account  in which the game is
                played.  NOTE:   If GLOBAL is set to TRUE,  you  MUST  have
                PRIV.SBR  on  the system in DSK0:[7,6] and to  assure  file
                integrity you MUST  define  a  file  locking mechanism (See
                LOCK)  !!!!!!!   FULL  FILE  SPECS  ONLY  (No Erz). 
                Default Value: FALSE

LOCK            If more than one user is allowed  to  access the BITMAP and
                HIGH SCORE files simultaneously (Either GLOBALLY or LOCALLY
                in  the  same  account)  it  is HIGHLY RECOMMENDED that you
                define a file locking mechanism.   If  LOKSER  is currently
                installed on your system then LOCK=LOKSER will be your best
                bet.   If you are running without LOKSER then you  may  use
                LOCK=XLOCK  (be  sure  DSK0:XLOCK.SBR[7,6]  is  loaded into
                System Memory). 
                Default Value: LOKSER

INPUT           Although  the Program requires no external  subroutines,  a
                facility exists for defining  an  external input routine of
                your choice.  If you have any such routines on your system,
                contact  me for further information.  As  of  Version  1.2A
                INFLD has been added. 
                Default Value: BASIC

STROBE          If you have  defined  an  input routine which supports left
                and right arrows, STROBE=TRUE will enable a strobe oriented
                option list when choosing next move. 
                Default Value: TRUE

[*] NEWRULES    No Longer Applicable.  Ignored if found in INI.

PRIZES          In  an attempt to closer resemble that other  game,  prizes
                have been added.  PRIZES=TRUE will place a prize in the box
                1 out of every PRZODDS  time after round 1.  The prize will
                be explained prior to the  round  and  the  slot  which  it
                occupies  will toggle with a money field every cycle of the
                spin.  If landed  on when the prize is showing, an asterisk
                will appear next to the score of the lucky player.  Solving
                the  puzzle  at  any time  therafter  (without  landing  on
                Bankrupt) will add  the  value of that prize to the round's
                score. NOTE:  You MUST have  the  file  "VANNA.PRZ"  in the
                same account as your Puzzle file !
                Default Value: True

PRZODDS         Defines the odds (1 in PRZODDS) of a Prize  being  included
                in  each round after round 1.  This parameter is ignored if
                PRIZES is set to FALSE. 
                Default Value: 2

DRAG            Enables a simulated DRAG COEFFICIENT  when  spinning.  When
                enabled,  the  wheel  will gradually decrease in speed when
                spun.  The intention here  is  to  more  closely  emulate a
                mechanical  spin  and, when used with SETFORCE, allows  the
                player to attempt landing in chosen squares. 
                Default Value: False

SETFORCE        When  set  to  TRUE,  this  parameter  will display a guage
                (either  on  bottom of screen or under puzzle as determined
                by HIGUAGE) which may be incremented or decremented by # or
                Arrow Movement  (See  STROBE)  to determine the strength of
                the spin.  As the spin progresses,  the  guage  decrements. 
                Gives  the spinner more control over the spin, but  may  or
                may not be to your liking. Try it, you may like it! 
                Default Value: False

HIGUAGE         Should you decide to use SETFORCE,  this  paremeter  may be
                used  to  move  the  location  of  the spin strength guage. 
                HIGUAGE=TRUE will place the guage directly under the puzzle
                file.  Should you find this distracting,  set HIGUAGE=FALSE
                and  the  guage  will appear at the bottom of  the  screen.
                Default Value: False

The following enhancement was suggested by  Doug  Vegge.  These  Parameters
will ONLY work if INPUT=INFLD and are otherwise ignored.


     TIMEOUT           Enables or Disables the Timeout feature of INFLD
                       Default Value: FALSE

The following Time parameters may be set to 0 if you do not wish timeout to
be enabled for that phase of the game.


     BONTIM            Defines the number of seconds for  each  attempt  at
                       the bonus puzzle.  If you prefer  to  restrict  time
                       only, set ATTEMPTS to 1.

     SLVTIM            Defines the number of seconds for  each  attempt  at
                       solving the various "round" puzzles.

     PLYTIM            Defines the number of seconds  for  timeout  in  all
                       other phases of the game.



BOOLEAN values may be expressed as ("TRUE" or "ON") or ("FALSE" or  "OFF").
If no INI file is found, the default parameters will be used !



An example of an acceptable INI file:

SLEEP=TRUE                      ;(Use SLEEP.SBR for Waits) [*]
LOGIC=TRUE                      ;(Set Puzzle-size Logic On)
LOGMIN=30                       ;(Set Min Puzzle-size rounds 4-5 to 30)
LOGMAX=24                       ;(Set Max Puzzle-size in Bonus Round to 24)
PASSES=10                       ;(Allow 10 Passes for Puzzle selection)
DISPLAY=FALSE                   ;(Don't Display # of Passes thus far)
BEEP=TRUE                       ;(Enable Terminal Beep)
ODDS=2                          ;(Odds are 1:2 that wanna will botch puzzle)
BONUS=TRUE                      ;(Enable Botch Bonus)
ATTEMPTS=4                      ;(Allow 4 attempts at Bonus Puzzle)
SPEED=1	                        ;(Set Normal Screen Output Speed)
CHAIN=GAMMNU                    ;(chain to "GAMMNU.RUN" upon exit)
ROTATE=TRUE                     ;(Rotate $ Positions each round)
VERIFY=TRUE                     ;(Verify header record puzzle count)
DATA=DSK0:VANNA[7,6]            ;(Puzzle file: DSK0:VANNA.DAT[7,6])
GLOBAL=FALSE                    ;(Bitmap and High Score files in user account)
LOCK=LOKSER                     ;(LOKSER enabled)
PRIZES=TRUE                     ;(enable Prizes)
PRZODDS=2                       ;(set odds of prize on board to 1:2)
SETFORCE=TRUE                   ;(enable spin-strength guage)
HIGUAGE=FALSE                   ;(spin-strength guage @ Bottom of screen)

Optional Additions to INI file w/INFLD:

INPUT=INFLD                ;(Enable INFLD as input routine)
TIMEOUT=TRUE               ;(Enable INFLD Timeout Feature)
BONTIM=45                  ;(Timeout in seconds for Bonus Round)
SLVTIM=30                  ;(Timeout in seconds for Puzzle Solution)
PLYTIM=00                  ;(Timeout in seconds for Other Play)
STROBE=ON                  ;(Inp Rtn Option Strobe ON)
ATTEMPTS=1                 ;(Allow 1 attempt at Bonus Puzzle)


 We play 5 Rounds, and the winner goes on to the Bonus Round to attempt to
 add $25,000 (or More) to his/her score.  In  the  event  of  a  tie,  the
 players involved will play tie-breaker rounds until the  tie  is  broken.

 Well, that's about it. The rest you probably already Know.  Have Fun !!!!


.
